Ext.onReady(function()
{
	var pageUrl = intelli.config.admin_url + '/newsletters/emails/';

	if (Ext.get('js-grid-placeholder'))
	{
		var urlParam = intelli.urlVal('status');

		intelli.newsletters =
		{
			columns: [
				'expander',
				{name: 'subj', title: _t('title'), width: 2, editor: 'text'},
				{name: 'date_added', title: _t('date'), width: 120, editor: 'date'},
				{name: 'from_name', title: _t('sender'), width: 2, editor: 'text'},
				{name: 'total', title: _t('amount'), width: 2, editor: 'text'},
				'delete',
				'selection'
			],
			expanderTemplate: '{body}',
			fields: ['body'],
			storeParams: urlParam ? {status: urlParam} : null,
			url: pageUrl
		};
		intelli.newsletters = new IntelliGrid(intelli.newsletters, false);
		intelli.newsletters.toolbar = Ext.create('Ext.Toolbar', {items:[
			{
				emptyText: _t('text'),
				name: 'text',
				listeners: intelli.gridHelper.listener.specialKey,
				width: 275,
				xtype: 'textfield'
			},{
				displayField: 'title',
				editable: false,
				emptyText: _t('status'),
				id: 'fltStatus',
				name: 'status',
				store: intelli.newsletters.stores.statuses,
				typeAhead: true,
				valueField: 'value',
				xtype: 'combo'
			},{
				handler: function(){intelli.gridHelper.search(intelli.newsletters);},
				id: 'fltBtn',
				text: '<i class="i-search"></i> ' + _t('search')
			},{
				handler: function(){intelli.gridHelper.search(intelli.newsletters, true);},
				text: '<i class="i-close"></i> ' + _t('reset')
			}]});
		if (urlParam)
		{
			Ext.getCmp('fltStatus').setValue(urlParam);
		}
		intelli.newsletters.init();
	}
});
