Ext.onReady(function()
{
	var pageUrl = intelli.config.admin_url + '/newsletters/';

	if (Ext.get('js-grid-placeholder'))
	{
		var urlParam = intelli.urlVal('status');

		intelli.newsletters =
		{
			columns: [
				'selection',
				{name: 'email', title: _t('email'), width: 2, editor: 'text'},
				{name: 'topics', title: _t('packages'), width: 300, renderer: function(value) {
						var packages = '';

						if (value != '')
						{
							var list = value.split('|');
							$.each(list, function(i, v) {
								list[i] = _t(v.split(':')[0]);
							});
							packages = list.join(', ');
						}

						return packages;
					}},
				{name: 'last_sent', title: _t('last_sent'), width: 200},
				'status',
				'delete'
			],
			storeParams: urlParam ? {status: urlParam} : null,
			url: pageUrl
		};
		intelli.newsletters = new IntelliGrid(intelli.newsletters, false);
		intelli.newsletters.toolbar = Ext.create('Ext.Toolbar', {items:
		[
			{
				emptyText: _t('text'),
				name: 'text',
				listeners: intelli.gridHelper.listener.specialKey,
				xtype: 'textfield'
			}, {
				displayField: 'title',
				editable: false,
				emptyText: _t('status'),
				id: 'fltStatus',
				name: 'status',
				store: intelli.newsletters.stores.statuses,
				typeAhead: true,
				valueField: 'value',
				xtype: 'combo'
			}, {
				handler: function(){intelli.gridHelper.search(intelli.newsletters);},
				id: 'fltBtn',
				text: '<i class="i-search"></i> ' + _t('search')
			}, {
				handler: function(){intelli.gridHelper.search(intelli.newsletters, true);},
				text: '<i class="i-close"></i> ' + _t('reset')
			}
		]});

		if (urlParam)
		{
			Ext.getCmp('fltStatus').setValue(urlParam);
		}
		
		intelli.newsletters.init();
	}
});
